Index: contrib/ntp/ntpd/ntpd-opts.c
===================================================================
--- contrib/ntp/ntpd/ntpd-opts.c	(版本 314126)
+++ contrib/ntp/ntpd/ntpd-opts.c	(版本 316722)
@@ -686,11 +686,11 @@
  *  slew option description:
  */
 /** Descriptive text for the slew option */
-#define SLEW_DESC      (ntpd_opt_strs+2608)
+#define SLEW_DESC      (ntpd_opt_strs+2609)
 /** Upper-cased name for the slew option */
-#define SLEW_NAME      (ntpd_opt_strs+2631)
+#define SLEW_NAME      (ntpd_opt_strs+2632)
 /** Name string for the slew option */
-#define SLEW_name      (ntpd_opt_strs+2636)
+#define SLEW_name      (ntpd_opt_strs+2637)
 /** Compiled in flag settings for the slew option */
 #define SLEW_FLAGS     (OPTST_DISABLED)
 
@@ -699,11 +699,11 @@
  */
 #ifdef SYS_WINNT
 /** Descriptive text for the usepcc option */
-#define USEPCC_DESC      (ntpd_opt_strs+2641)
+#define USEPCC_DESC      (ntpd_opt_strs+2642)
 /** Upper-cased name for the usepcc option */
-#define USEPCC_NAME      (ntpd_opt_strs+2678)
+#define USEPCC_NAME      (ntpd_opt_strs+2679)
 /** Name string for the usepcc option */
-#define USEPCC_name      (ntpd_opt_strs+2685)
+#define USEPCC_name      (ntpd_opt_strs+2686)
 /** Compiled in flag settings for the usepcc option */
 #define USEPCC_FLAGS     (OPTST_DISABLED)
 
@@ -719,11 +719,11 @@
  */
 #ifdef SYS_WINNT
 /** Descriptive text for the pccfreq option */
-#define PCCFREQ_DESC      (ntpd_opt_strs+2692)
+#define PCCFREQ_DESC      (ntpd_opt_strs+2693)
 /** Upper-cased name for the pccfreq option */
-#define PCCFREQ_NAME      (ntpd_opt_strs+2735)
+#define PCCFREQ_NAME      (ntpd_opt_strs+2736)
 /** Name string for the pccfreq option */
-#define PCCFREQ_name      (ntpd_opt_strs+2743)
+#define PCCFREQ_name      (ntpd_opt_strs+2744)
 /** Compiled in flag settings for the pccfreq option */
 #define PCCFREQ_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -740,11 +740,11 @@
  */
 #ifdef HAVE_DNSREGISTRATION
 /** Descriptive text for the mdns option */
-#define MDNS_DESC      (ntpd_opt_strs+2751)
+#define MDNS_DESC      (ntpd_opt_strs+2752)
 /** Upper-cased name for the mdns option */
-#define MDNS_NAME      (ntpd_opt_strs+2786)
+#define MDNS_NAME      (ntpd_opt_strs+2787)
 /** Name string for the mdns option */
-#define MDNS_name      (ntpd_opt_strs+2791)
+#define MDNS_name      (ntpd_opt_strs+2792)
 /** Compiled in flag settings for the mdns option */
 #define MDNS_FLAGS     (OPTST_DISABLED)
 
@@ -758,11 +758,11 @@
 /*
  *  Help/More_Help/Version option descriptions:
  */
-#define HELP_DESC       (ntpd_opt_strs+2796)
-#define HELP_name       (ntpd_opt_strs+2840)
+#define HELP_DESC       (ntpd_opt_strs+2797)
+#define HELP_name       (ntpd_opt_strs+2841)
 #ifdef HAVE_WORKING_FORK
-#define MORE_HELP_DESC  (ntpd_opt_strs+2845)
-#define MORE_HELP_name  (ntpd_opt_strs+2890)
+#define MORE_HELP_DESC  (ntpd_opt_strs+2846)
+#define MORE_HELP_name  (ntpd_opt_strs+2891)
 #define MORE_HELP_FLAGS (OPTST_IMM | OPTST_NO_INIT)
 #else
 #define MORE_HELP_DESC  HELP_DESC
@@ -775,8 +775,8 @@
 #  define VER_FLAGS     (OPTST_SET_ARGTYPE(OPARG_TYPE_STRING) | \
                          OPTST_ARG_OPTIONAL | OPTST_IMM | OPTST_NO_INIT)
 #endif
-#define VER_DESC        (ntpd_opt_strs+2900)
-#define VER_name        (ntpd_opt_strs+2936)
+#define VER_DESC        (ntpd_opt_strs+2901)
+#define VER_name        (ntpd_opt_strs+2937)
 /**
  *  Declare option callback procedures
  */
@@ -1258,21 +1258,21 @@
 
 /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
 /** Reference to the upper cased version of ntpd. */
-#define zPROGNAME       (ntpd_opt_strs+2944)
+#define zPROGNAME       (ntpd_opt_strs+2945)
 /** Reference to the title line for ntpd usage. */
-#define zUsageTitle     (ntpd_opt_strs+2949)
+#define zUsageTitle     (ntpd_opt_strs+2950)
 /** There is no ntpd configuration file. */
 #define zRcName         NULL
 /** There are no directories to search for ntpd config files. */
 #define apzHomeList     NULL
 /** The ntpd program bug email address. */
-#define zBugsAddr       (ntpd_opt_strs+3080)
+#define zBugsAddr       (ntpd_opt_strs+3082)
 /** Clarification/explanation of what ntpd does. */
-#define zExplain        (ntpd_opt_strs+3114)
+#define zExplain        (ntpd_opt_strs+3116)
 /** Extra detail explaining what ntpd does. */
 #define zDetail         (NULL)
 /** The full version string for ntpd. */
-#define zFullVersion    (ntpd_opt_strs+3116)
+#define zFullVersion    (ntpd_opt_strs+3118)
 /* extracted from optcode.tlib near line 364 */
 
 #if defined(ENABLE_NLS)
@@ -1529,8 +1529,8 @@
      translate option names.
    */
   /* referenced via ntpdOptions.pzCopyright */
-  puts(_("ntpd 4.2.8p9\n\
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("ntpd 4.2.8p10\n\
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -1670,7 +1670,7 @@
   puts(_("output version information and exit"));
 
   /* referenced via ntpdOptions.pzUsageTitle */
-  puts(_("ntpd - NTP daemon program - Ver. 4.2.8p9\n\
+  puts(_("ntpd - NTP daemon program - Ver. 4.2.8p10\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... \\\n\
 \t\t[ <server1> ... <serverN> ]\n"));
 
@@ -1678,7 +1678,7 @@
   puts(_("\n"));
 
   /* referenced via ntpdOptions.pzFullVersion */
-  puts(_("ntpd 4.2.8p9"));
+  puts(_("ntpd 4.2.8p10"));
 
   /* referenced via ntpdOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
Index: contrib/ntp/ntpd/ntp.conf.5man
===================================================================
--- contrib/ntp/ntpd/ntp.conf.5man	(版本 314126)
+++ contrib/ntp/ntpd/ntp.conf.5man	(版本 316722)
@@ -10,11 +10,11 @@
 .ds B-Font B
 .ds I-Font I
 .ds R-Font R
-.TH ntp.conf 5man "21 Nov 2016" "4.2.8p9" "File Formats"
+.TH ntp.conf 5man "21 Mar 2017" "4.2.8p10-beta" "File Formats"
 .\"
-.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-Q_ai3f/ag-2_aa2f)
+.\" EDIT THIS FILE WITH CAUTION (/tmp/.ag-UAaqtC/ag-6AaisC)
 .\"
-.\" It has been AutoGen-ed November 21, 2016 at 08:01:41 AM by AutoGen 5.18.5
+.\" It has been AutoGen-ed March 21, 2017 at 10:30:48 AM by AutoGen 5.18.5
 .\" From the definitions ntp.conf.def
 .\" and the template file agman-cmd.tpl
 .SH NAME
@@ -3182,7 +3182,7 @@
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH BUGS
 The syntax checking is not picky; some combinations of
Index: contrib/ntp/ntpd/ntp.conf.mdoc.in
===================================================================
--- contrib/ntp/ntpd/ntp.conf.mdoc.in	(版本 314126)
+++ contrib/ntp/ntpd/ntp.conf.mdoc.in	(版本 316722)
@@ -1,9 +1,9 @@
-.Dd November 21 2016
+.Dd March 21 2017
 .Dt NTP_CONF 5 File Formats
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntp.mdoc)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:03 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:31:09 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp.conf.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -2987,7 +2987,7 @@
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh BUGS
 The syntax checking is not picky; some combinations of
Index: contrib/ntp/ntpd/ntp.keys.man.in
===================================================================
--- contrib/ntp/ntpd/ntp.keys.man.in	(版本 314126)
+++ contrib/ntp/ntpd/ntp.keys.man.in	(版本 316722)
@@ -1,8 +1,8 @@
-.TH ntp.keys 5 "21 Nov 2016" "4.2.8p9" "File Formats"
+.TH ntp.keys 5 "21 Mar 2017" "4.2.8p10" "File Formats"
 .\"
 .\"  EDIT THIS FILE WITH CAUTION  (ntp.man)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:01:46 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:44:10 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp.keys.def
 .\"  and the template file   agman-file.tpl
 .Sh NAME
@@ -168,7 +168,7 @@
 .SH "AUTHORS"
 The University of Delaware and Network Time Foundation
 .SH "COPYRIGHT"
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .SH "BUGS"
 Please send bug reports to: http://bugs.ntp.org, bugs@ntp.org
Index: contrib/ntp/ntpd/ntp_crypto.c
===================================================================
--- contrib/ntp/ntpd/ntp_crypto.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_crypto.c	(版本 316722)
@@ -22,11 +22,15 @@
 #include "ntp_calendar.h"
 #include "ntp_leapsec.h"
 
+#include "openssl/asn1.h"
 #include "openssl/bn.h"
+#include "openssl/crypto.h"
 #include "openssl/err.h"
 #include "openssl/evp.h"
+#include "openssl/opensslv.h"
 #include "openssl/pem.h"
 #include "openssl/rand.h"
+#include "openssl/x509.h"
 #include "openssl/x509v3.h"
 #include "libssl_compat.h"
 
@@ -193,7 +197,7 @@
 static	int	crypto_mv	(struct exten *, struct peer *);
 static	int	crypto_send	(struct exten *, struct value *, int);
 static	tstamp_t crypto_time	(void);
-static	void	asn_to_calendar		(ASN1_TIME *, struct calendar*);
+static	void	asn_to_calendar		(const ASN1_TIME *, struct calendar*);
 static	struct cert_info *cert_parse (const u_char *, long, tstamp_t);
 static	int	cert_sign	(struct exten *, struct value *);
 static	struct cert_info *cert_install (struct exten *, struct peer *);
@@ -2010,7 +2014,7 @@
 static
 void
 asn_to_calendar	(
-	ASN1_TIME *asn1time,	/* pointer to ASN1_TIME structure */
+	const ASN1_TIME *asn1time,	/* pointer to ASN1_TIME structure */
 	struct calendar *pjd	/* pointer to result */
 	)
 {
@@ -3187,8 +3191,8 @@
 	serial = ASN1_INTEGER_new();
 	ASN1_INTEGER_set(serial, tstamp);
 	X509_set_serialNumber(cert, serial);
-	X509_gmtime_adj(X509_get_notBefore(cert), 0L);
-	X509_gmtime_adj(X509_get_notAfter(cert), YEAR);
+	X509_gmtime_adj(X509_getm_notBefore(cert), 0L);
+	X509_gmtime_adj(X509_getm_notAfter(cert), YEAR);
 	subj = X509_get_issuer_name(cert);
 	X509_NAME_add_entry_by_txt(subj, "commonName", MBSTRING_ASC,
 	    hostval.ptr, strlen((const char *)hostval.ptr), -1, 0);
@@ -3497,8 +3501,8 @@
 		return (NULL);
 	}
 	ret->issuer = estrdup(pch + 3);
-	asn_to_calendar(X509_get_notBefore(cert), &(ret->first));
-	asn_to_calendar(X509_get_notAfter(cert), &(ret->last));
+	asn_to_calendar(X509_get0_notBefore(cert), &(ret->first));
+	asn_to_calendar(X509_get0_notAfter(cert), &(ret->last));
 
 	/*
 	 * Extract extension fields. These are ad hoc ripoffs of
@@ -3922,7 +3926,8 @@
 		RAND_seed(&seed, sizeof(l_fp));
 		RAND_write_file(randfile);
 		DPRINTF(1, ("crypto_setup: OpenSSL version %lx random seed file %s bytes read %d\n",
-			    SSLeay(), randfile, bytes));
+			    OpenSSL_version_num(), randfile, bytes));
+
 	}
 
 	/*
Index: contrib/ntp/ntpd/ntp_parser.h
===================================================================
--- contrib/ntp/ntpd/ntp_parser.h	(版本 314126)
+++ contrib/ntp/ntpd/ntp_parser.h	(版本 316722)
@@ -446,7 +446,7 @@
 
 union YYSTYPE
 {
-#line 51 "../../ntpd/ntp_parser.y" /* yacc.c:1909  */
+#line 51 "ntp_parser.y" /* yacc.c:1909  */
 
 	char *			String;
 	double			Double;
Index: contrib/ntp/ntpd/ntp_scanner.c
===================================================================
--- contrib/ntp/ntpd/ntp_scanner.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_scanner.c	(版本 316722)
@@ -892,7 +892,6 @@
 		}
 	}
 
-	instring = FALSE;
 	if (FOLLBY_STRING == followedby)
 		followedby = FOLLBY_TOKEN;
 
Index: contrib/ntp/ntpd/ntpd.1ntpdmdoc
===================================================================
--- contrib/ntp/ntpd/ntpd.1ntpdmdoc	(版本 314126)
+++ contrib/ntp/ntpd/ntpd.1ntpdmdoc	(版本 316722)
@@ -1,9 +1,9 @@
-.Dd November 21 2016
+.Dd March 21 2017
 .Dt NTPD 1ntpdmdoc User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpd-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:08 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:44:23 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpd-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -886,7 +886,7 @@
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh BUGS
 The
Index: contrib/ntp/ntpd/ntpd.mdoc.in
===================================================================
--- contrib/ntp/ntpd/ntpd.mdoc.in	(版本 314126)
+++ contrib/ntp/ntpd/ntpd.mdoc.in	(版本 316722)
@@ -1,9 +1,9 @@
-.Dd November 21 2016
+.Dd March 21 2017
 .Dt NTPD @NTPD_MS@ User Commands
 .Os
 .\"  EDIT THIS FILE WITH CAUTION  (ntpd-opts.mdoc)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:08 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:44:23 AM by AutoGen 5.18.5
 .\"  From the definitions    ntpd-opts.def
 .\"  and the template file   agmdoc-cmd.tpl
 .Sh NAME
@@ -886,7 +886,7 @@
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh BUGS
 The
Index: contrib/ntp/ntpd/ntp.keys.5mdoc
===================================================================
--- contrib/ntp/ntpd/ntp.keys.5mdoc	(版本 314126)
+++ contrib/ntp/ntpd/ntp.keys.5mdoc	(版本 316722)
@@ -1,9 +1,9 @@
-.Dd November 21 2016
+.Dd March 21 2017
 .Dt NTP_KEYS 5mdoc File Formats
 .Os SunOS 5.10
 .\"  EDIT THIS FILE WITH CAUTION  (ntp.mdoc)
 .\"
-.\"  It has been AutoGen-ed  November 21, 2016 at 08:02:06 AM by AutoGen 5.18.5
+.\"  It has been AutoGen-ed  March 21, 2017 at 10:44:22 AM by AutoGen 5.18.5
 .\"  From the definitions    ntp.keys.def
 .\"  and the template file   agmdoc-file.tpl
 .Sh NAME
@@ -155,7 +155,7 @@
 .Sh "AUTHORS"
 The University of Delaware and Network Time Foundation
 .Sh "COPYRIGHT"
-Copyright (C) 1992\-2016 The University of Delaware and Network Time Foundation all rights reserved.
+Copyright (C) 1992\-2017 The University of Delaware and Network Time Foundation all rights reserved.
 This program is released under the terms of the NTP license, <http://ntp.org/license>.
 .Sh "BUGS"
 Please send bug reports to: http://bugs.ntp.org, bugs@ntp.org
Index: contrib/ntp/ntpd/ntp_config.c
===================================================================
--- contrib/ntp/ntpd/ntp_config.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_config.c	(版本 316722)
@@ -361,6 +361,9 @@
 static u_int32 get_pfxmatch(const char **, struct masks *);
 static u_int32 get_match(const char *, struct masks *);
 static u_int32 get_logmask(const char *);
+static int/*BOOL*/ is_refclk_addr(const address_node * addr);
+
+
 #ifndef SIM
 static int getnetnum(const char *num, sockaddr_u *addr, int complain,
 		     enum gnn_type a_type);
@@ -367,7 +370,23 @@
 
 #endif
 
+#if defined(__GNUC__) /* this covers CLANG, too */
+static void  __attribute__((noreturn,format(printf,1,2))) fatal_error(const char *fmt, ...)
+#elif defined(_MSC_VER)
+static void __declspec(noreturn) fatal_error(const char *fmt, ...)
+#else
+static void fatal_error(const char *fmt, ...)
+#endif
+{
+	va_list va;
+	
+	va_start(va, fmt);
+	mvsyslog(LOG_EMERG, fmt, va);
+	va_end(va);
+	_exit(1);
+}
 
+    
 /* FUNCTIONS FOR INITIALIZATION
  * ----------------------------
  */
@@ -1266,7 +1285,10 @@
 			break;
 
 		case T_Ttl:
-			if (option->value.u >= MAX_TTL) {
+			if (is_refclk_addr(addr)) {
+				msyslog(LOG_ERR, "'ttl' does not apply for refclocks");
+				errflag = 1;
+			} else if (option->value.u >= MAX_TTL) {
 				msyslog(LOG_ERR, "ttl: invalid argument");
 				errflag = 1;
 			} else {
@@ -1275,7 +1297,12 @@
 			break;
 
 		case T_Mode:
-			my_node->ttl = option->value.u;
+			if (is_refclk_addr(addr)) {
+				my_node->ttl = option->value.u;
+			} else {
+				msyslog(LOG_ERR, "'mode' does not apply for network peers");
+				errflag = 1;
+			}
 			break;
 
 		case T_Key:
@@ -1328,8 +1355,8 @@
 	)
 {
 	unpeer_node *	my_node;
-	u_int		u;
-	char *		pch;
+	u_long		u;
+	const u_char *	pch;
 
 	my_node = emalloc_zero(sizeof(*my_node));
 
@@ -1338,16 +1365,15 @@
 	 * its generic T_String definition of a name/address "address".
 	 * We treat all valid 16-bit numbers as association IDs.
 	 */
-	pch = addr->address;
-	while (*pch && isdigit((unsigned char)*pch))
-		pch++;
-
-	if (!*pch
-	    && 1 == sscanf(addr->address, "%u", &u)
-	    && u <= ASSOCID_MAX) {
+	for (u = 0, pch = (u_char*)addr->address; isdigit(*pch); ++pch) {
+		/* accumulate with overflow retention */
+		u = (10 * u + *pch - '0') | (u & 0xFF000000u);
+	}
+	
+	if (!*pch && u <= ASSOCID_MAX) {
 		my_node->assocID = (associd_t)u;
+		my_node->addr = NULL;
 		destroy_address_node(addr);
-		my_node->addr = NULL;
 	} else {
 		my_node->assocID = 0;
 		my_node->addr = addr;
@@ -1841,16 +1867,12 @@
 
 	/* Crypto Command */
 #ifdef AUTOKEY
-# ifdef __GNUC__
-	item = -1;	/* quiet warning */
-# endif
 	my_val = HEAD_PFIFO(ptree->auth.crypto_cmd_list);
 	for (; my_val != NULL; my_val = my_val->link) {
 		switch (my_val->attr) {
 
 		default:
-			INSIST(0);
-			break;
+			fatal_error("config_auth: attr-token=%d", my_val->attr);
 
 		case T_Host:
 			item = CRYPTO_CONF_PRIV;
@@ -1996,40 +2018,96 @@
 	int		item;
 	double		val;
 
-#ifdef __GNUC__
-	item = -1;	/* quiet warning */
-#endif
+	/* [Bug 2896] For the daemon to work properly it is essential
+	 * that minsane < minclock <= maxclock.
+	 *
+	 * If either constraint is violated, the daemon will be or might
+	 * become dysfunctional. Fixing the values is too fragile here,
+	 * since three variables with interdependecies are involved. We
+	 * just log an error but do not stop: This might be caused by
+	 * remote config, and it might be fixed by remote config, too.
+	 */ 
+	int l_maxclock = sys_maxclock;
+	int l_minclock = sys_minclock;
+	int l_minsane  = sys_minsane;
+
+	/* -*- phase one: inspect / sanitize the values */
 	tos = HEAD_PFIFO(ptree->orphan_cmds);
 	for (; tos != NULL; tos = tos->link) {
 		val = tos->value.d;
 		switch(tos->attr) {
-
 		default:
-			INSIST(0);
 			break;
 
 		case T_Bcpollbstep:
 			if (val > 4) {
 				msyslog(LOG_WARNING,
-					"Using maximum bcpollbstep ceiling %d, %g requested",
-					4, val);
-				val = 4;
+					"Using maximum bcpollbstep ceiling %d, %d requested",
+					4, (int)val);
+				tos->value.d = 4;
 			} else if (val < 0) {
 				msyslog(LOG_WARNING,
-					"Using minimum bcpollbstep floor %d, %g requested",
-					0, val);
-				val = 0;
+					"Using minimum bcpollbstep floor %d, %d requested",
+					0, (int)val);
+				tos->value.d = 0;
 			}
-			item = PROTO_BCPOLLBSTEP;
 			break;
-
+			
 		case T_Ceiling:
 			if (val > STRATUM_UNSPEC - 1) {
 				msyslog(LOG_WARNING,
-					"Using maximum tos ceiling %d, %g requested",
-					STRATUM_UNSPEC - 1, val);
-				val = STRATUM_UNSPEC - 1;
+					"Using maximum tos ceiling %d, %d requested",
+					STRATUM_UNSPEC - 1, (int)val);
+				tos->value.d = STRATUM_UNSPEC - 1;
+			} else if (val < 1) {
+				msyslog(LOG_WARNING,
+					"Using minimum tos floor %d, %d requested",
+					1, (int)val);
+				tos->value.d = 1;
 			}
+			break;
+
+		case T_Minclock:
+			if ((int)tos->value.d < 1)
+				tos->value.d = 1;
+			l_minclock = (int)tos->value.d;
+			break;
+
+		case T_Maxclock:
+			if ((int)tos->value.d < 1)
+				tos->value.d = 1;
+			l_maxclock = (int)tos->value.d;
+			break;
+
+		case T_Minsane:
+			if ((int)tos->value.d < 1)
+				tos->value.d = 1;
+			l_minsane = (int)tos->value.d;
+			break;
+		}
+	}
+
+	if ( ! (l_minsane < l_minclock && l_minclock <= l_maxclock)) {
+		msyslog(LOG_ERR,
+			"tos error: must have minsane (%d) < minclock (%d) <= maxclock (%d)"
+			" - daemon will not operate properly!",
+			l_minsane, l_minclock, l_maxclock);
+	}
+	
+	/* -*- phase two: forward the values to the protocol machinery */
+	tos = HEAD_PFIFO(ptree->orphan_cmds);
+	for (; tos != NULL; tos = tos->link) {
+		val = tos->value.d;
+		switch(tos->attr) {
+
+		default:
+			fatal_error("config-tos: attr-token=%d", tos->attr);
+
+		case T_Bcpollbstep:
+			item = PROTO_BCPOLLBSTEP;
+			break;
+
+		case T_Ceiling:
 			item = PROTO_CEILING;
 			break;
 
@@ -2172,8 +2250,7 @@
 				switch (my_opts->value.i) {
 
 				default:
-					INSIST(0);
-					break;
+					fatal_error("config-monitor: type-token=%d", my_opts->value.i);
 
 				case T_None:
 					filegen_type = FILEGEN_NONE;
@@ -2409,8 +2486,7 @@
 			switch (curr_flag->i) {
 
 			default:
-				INSIST(0);
-				break;
+				fatal_error("config-access: flag-type-token=%d", curr_flag->i);
 
 			case T_Ntpport:
 				mflags |= RESM_NTPONLY;
@@ -2640,8 +2716,7 @@
 		switch (rlimit_av->attr) {
 
 		default:
-			INSIST(0);
-			break;
+			fatal_error("config-rlimit: value-token=%d", rlimit_av->attr);
 
 		case T_Memlock:
 			/* What if we HAVE_OPT(SAVECONFIGQUIT) ? */
@@ -2714,16 +2789,12 @@
 	attr_val *	tinker;
 	int		item;
 
-#ifdef __GNUC__
-	item = -1;	/* quiet warning */
-#endif
 	tinker = HEAD_PFIFO(ptree->tinker);
 	for (; tinker != NULL; tinker = tinker->link) {
 		switch (tinker->attr) {
 
 		default:
-			INSIST(0);
-			break;
+			fatal_error("config_tinker: attr-token=%d", tinker->attr);
 
 		case T_Allan:
 			item = LOOP_ALLAN;
@@ -2830,16 +2901,7 @@
 		switch (curr_node->match_class) {
 
 		default:
-#ifdef __GNUC__
-			/*
-			 * this assignment quiets a gcc "may be used
-			 * uninitialized" warning and is here for no
-			 * other reason.
-			 */
-			match_type = MATCH_ALL;
-#endif
-			INSIST(FALSE);
-			break;
+			fatal_error("config_nic_rules: match-class-token=%d", curr_node->match_class);
 
 		case 0:
 			/*
@@ -2890,16 +2952,7 @@
 		switch (curr_node->action) {
 
 		default:
-#ifdef __GNUC__
-			/*
-			 * this assignment quiets a gcc "may be used
-			 * uninitialized" warning and is here for no
-			 * other reason.
-			 */
-			action = ACTION_LISTEN;
-#endif
-			INSIST(FALSE);
-			break;
+			fatal_error("config_nic_rules: action-token=%d", curr_node->action);
 
 		case T_Listen:
 			action = ACTION_LISTEN;
@@ -3087,8 +3140,7 @@
 			ntp_syslogmask = get_logmask(my_lc->value.s);
 			break;
 		default:
-			INSIST(0);
-			break;
+			fatal_error("config-logconfig: modifier='%c'", my_lc->attr);
 		}
 	}
 }
@@ -3210,7 +3262,7 @@
 				"ttl: Number of TTL entries exceeds %zu. Ignoring TTL %d...",
 				COUNTOF(sys_ttl), curr_ttl->i);
 	}
-	sys_ttlmax = i - 1;
+	sys_ttlmax = (i) ? (i - 1) : 0;
 }
 #endif	/* !SIM */
 
@@ -3738,8 +3790,7 @@
 		switch (option->value.i) {
 
 		default:
-			INSIST(0);
-			break;
+			fatal_error("peerflag_bits: option-token=%d", option->value.i);
 
 		case T_Autokey:
 			peerflags |= FLAG_SKEY;
@@ -4040,10 +4091,10 @@
 	curr_unpeer = HEAD_PFIFO(ptree->unpeers);
 	for (; curr_unpeer != NULL; curr_unpeer = curr_unpeer->link) {
 		/*
-		 * Either AssocID will be zero, and we unpeer by name/
-		 * address addr, or it is nonzero and addr NULL.
+		 * If we have no address attached, assume we have to
+		 * unpeer by AssocID.
 		 */
-		if (curr_unpeer->assocID) {
+		if (!curr_unpeer->addr) {
 			p = findpeerbyassoc(curr_unpeer->assocID);
 			if (p != NULL) {
 				msyslog(LOG_NOTICE, "unpeered %s",
@@ -4051,7 +4102,6 @@
 				peer_clear(p, "GONE");
 				unpeer(p);
 			}
-
 			continue;
 		}
 
@@ -4070,7 +4120,6 @@
 				peer_clear(p, "GONE");
 				unpeer(p);
 			}
-
 			continue;
 		}
 		/*
@@ -4384,11 +4433,11 @@
 	config_mdnstries(ptree);
 	config_setvar(ptree);
 	config_ttl(ptree);
-	config_trap(ptree);
 	config_vars(ptree);
 
-	io_open_sockets();
+	io_open_sockets();	/* [bug 2837] dep. on config_vars() */
 
+	config_trap(ptree);	/* [bug 2923] dep. on io_open_sockets() */
 	config_other_modes(ptree);
 	config_peers(ptree);
 	config_unpeers(ptree);
@@ -4636,6 +4685,16 @@
 #endif
 }
 
+/* Hack to disambiguate 'server' statements for refclocks and network peers.
+ * Please note the qualification 'hack'. It's just that.
+ */
+static int/*BOOL*/
+is_refclk_addr(
+	const address_node * addr
+	)
+{
+	return addr && addr->address && !strncmp(addr->address, "127.127.", 6);
+}
 
 static void
 ntpd_set_tod_using(
@@ -5041,8 +5100,7 @@
 # endif /* RLIMIT_STACK */
 
 	    default:
-		INSIST(!"Unexpected setrlimit() case!");
-		break;
+		    fatal_error("ntp_rlimit: unexpected RLIMIT case: %d", rl_what);
 	}
 }
 #endif	/* HAVE_SETRLIMIT */
Index: contrib/ntp/ntpd/ntp_loopfilter.c
===================================================================
--- contrib/ntp/ntpd/ntp_loopfilter.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_loopfilter.c	(版本 316722)
@@ -1307,8 +1307,7 @@
 		if (freq < HUFFPUFF)
 			freq = HUFFPUFF;
 		sys_hufflen = (int)(freq / HUFFPUFF);
-		sys_huffpuff = emalloc(sizeof(sys_huffpuff[0]) *
-		    sys_hufflen);
+		sys_huffpuff = eallocarray(sys_hufflen, sizeof(sys_huffpuff[0]));
 		for (i = 0; i < sys_hufflen; i++)
 			sys_huffpuff[i] = 1e9;
 		sys_mindly = 1e9;
Index: contrib/ntp/ntpd/ntp_proto.c
===================================================================
--- contrib/ntp/ntpd/ntp_proto.c	(版本 314126)
+++ contrib/ntp/ntpd/ntp_proto.c	(版本 316722)
@@ -147,7 +147,7 @@
 int	sys_orphan = STRATUM_UNSPEC + 1; /* orphan stratum */
 int	sys_orphwait = NTP_ORPHWAIT; /* orphan wait */
 int	sys_beacon = BEACON;	/* manycast beacon interval */
-int	sys_ttlmax;		/* max ttl mapping vector index */
+u_int	sys_ttlmax;		/* max ttl mapping vector index */
 u_char	sys_ttl[MAX_TTL];	/* ttl mapping vector */
 
 /*
@@ -401,7 +401,7 @@
 			peer_xmit(peer);
 		} else if (   sys_survivors < sys_minclock
 			   || peer_associations < sys_maxclock) {
-			if (peer->ttl < (u_int32)sys_ttlmax)
+			if (peer->ttl < sys_ttlmax)
 				peer->ttl++;
 			peer_xmit(peer);
 		}
@@ -1691,9 +1691,13 @@
 
 		if (0) {
 		} else if (L_ISZERO(&p_org)) {
-			char *action;
+			const char *action;
 
+#ifdef BUG3361
+			msyslog(LOG_INFO,
+				"receive: BUG 3361: Clearing peer->aorg ");
 			L_CLR(&peer->aorg);
+#endif
 			/**/
 			switch (hismode) {
 			/* We allow 0org for: */
@@ -1712,6 +1716,7 @@
 				peer->flash |= TEST2;	/* bogus */
 				break;
 			    default:
+				action = "";	/* for cranky compilers / MSVC */
 				INSIST(!"receive(): impossible hismode");
 				break;
 			}
@@ -3719,8 +3724,9 @@
 			}
 		}
 		peer->t21_bytes = sendlen;
-		sendpkt(&peer->srcadr, peer->dstadr, sys_ttl[peer->ttl],
-		    &xpkt, sendlen);
+		sendpkt(&peer->srcadr, peer->dstadr,
+			sys_ttl[(peer->ttl >= sys_ttlmax) ? sys_ttlmax : peer->ttl],
+			&xpkt, sendlen);
 		peer->sent++;
 		peer->throttle += (1 << peer->minpoll) - 2;
 
@@ -4030,8 +4036,9 @@
 		exit (-1);
 	}
 	peer->t21_bytes = sendlen;
-	sendpkt(&peer->srcadr, peer->dstadr, sys_ttl[peer->ttl], &xpkt,
-	    sendlen);
+	sendpkt(&peer->srcadr, peer->dstadr,
+		sys_ttl[(peer->ttl >= sys_ttlmax) ? sys_ttlmax : peer->ttl],
+		&xpkt, sendlen);
 	peer->sent++;
 	peer->throttle += (1 << peer->minpoll) - 2;
 
@@ -4054,7 +4061,7 @@
 		    ntoa(&peer->srcadr), peer->hmode, xkeyid, sendlen,
 		    peer->keynumber));
 #else	/* !AUTOKEY follows */
-	DPRINTF(1, ("peer_xmit: at %ld %s->%s mode %d keyid %08x len %d\n",
+	DPRINTF(1, ("peer_xmit: at %ld %s->%s mode %d keyid %08x len %zu\n",
 		    current_time, peer->dstadr ?
 		    ntoa(&peer->dstadr->sin) : "-",
 		    ntoa(&peer->srcadr), peer->hmode, xkeyid, sendlen));
@@ -4352,8 +4359,9 @@
 	get_systime(&xmt_tx);
 	pool->aorg = xmt_tx;
 	HTONL_FP(&xmt_tx, &xpkt.xmt);
-	sendpkt(rmtadr, lcladr,	sys_ttl[pool->ttl], &xpkt,
-		LEN_PKT_NOMAC);
+	sendpkt(rmtadr, lcladr,
+		sys_ttl[(pool->ttl >= sys_ttlmax) ? sys_ttlmax : pool->ttl],
+		&xpkt, LEN_PKT_NOMAC);
 	pool->sent++;
 	pool->throttle += (1 << pool->minpoll) - 2;
 	DPRINTF(1, ("pool_xmit: at %ld %s->%s pool\n",
@@ -4722,10 +4730,9 @@
 	sys_stattime = current_time;
 	orphwait = current_time + sys_orphwait;
 	proto_clr_stats();
-	for (i = 0; i < MAX_TTL; i++) {
+	for (i = 0; i < MAX_TTL; ++i)
 		sys_ttl[i] = (u_char)((i * 256) / MAX_TTL);
-		sys_ttlmax = i;
-	}
+	sys_ttlmax = (MAX_TTL - 1);
 	hardpps_enable = 0;
 	stats_control = 1;
 }
Index: contrib/ntp/ntpd/ntpd-opts.h
===================================================================
--- contrib/ntp/ntpd/ntpd-opts.h	(版本 314126)
+++ contrib/ntp/ntpd/ntpd-opts.h	(版本 316722)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpd-opts.h)
  *
- *  It has been AutoGen-ed  November 21, 2016 at 07:59:42 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  March 21, 2017 at 10:42:11 AM by AutoGen 5.18.5
  *  From the definitions    ntpd-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpd program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -106,9 +106,9 @@
 /** count of all options for ntpd */
 #define OPTION_CT    38
 /** ntpd version */
-#define NTPD_VERSION       "4.2.8p9"
+#define NTPD_VERSION       "4.2.8p10"
 /** Full ntpd version text */
-#define NTPD_FULL_VERSION  "ntpd 4.2.8p9"
+#define NTPD_FULL_VERSION  "ntpd 4.2.8p10"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
